<?php
namespace Incoviba\Repository\Proyecto;

use Incoviba\Common\Ideal;
use Incoviba\Common\Define;
use Incoviba\Common\Implement;
use Incoviba\Repository;
use Incoviba\Model;

class EstadoProyecto extends Ideal\Repository
{
    public function __construct(
        Define\Connection $connection,
        protected Repository\Proyecto $proyectoRepository,
        protected TipoEstadoProyecto $tipoEstadoProyectoRepository
    )
    {
        parent::__construct($connection);
        $this->setTable('estado_proyecto');
    }

    public function create(?array $data = null): Model\Proyecto\EstadoProyecto
    {
        $map = (new Implement\Repository\MapperParser())
            ->register('proyecto', (new Implement\Repository\Mapper())
                ->setFactory((new Implement\Repository\Factory())
                    ->setCallable([$this->proyectoRepository, 'fetchById'])
                    ->setArgs([$data['proyecto']])))
            ->register('estado', (new Implement\Repository\Mapper())
                ->setProperty('tipoEstadoProyecto')
                ->setFunction(function($data) {
                    return $this->tipoEstadoProyectoRepository->fetchById($data['estado']);
                }))
            ->register('fecha', new Implement\Repository\Mapper\DateTime('fecha'))
        ;
        return $this->parseData(new Model\Proyecto\EstadoProyecto(), $data, $map);
    }
    public function save(Define\Model $model): Model\Proyecto\EstadoProyecto
    {
        $model->id = $this->saveNew(['proyecto', 'estado', 'fecha'], [
            $model->proyecto()->id,
            $model->tipoEstadoProyecto()->id,
            $model->fecha->format('Y-m-d')
        ]);
        return $model;
    }
    public function edit(Define\Model $model, array $new_data): Model\Proyecto\EstadoProyecto
    {
        return $this->update($model, ['proyecto', 'estado', 'fecha'], $new_data);
    }

    public function fetchByProyecto(int $proyecto_id): array
    {
        $query = "SELECT * FROM `{$this->getTable()}` WHERE `proyecto` = ?";
        return $this->fetchMany($query, [$proyecto_id]);
    }
    public function fetchCurrentByProyecto(int $proyecto_id): Model\Proyecto\EstadoProyecto
    {
        $query = "SELECT a.*
FROM `{$this->getTable()}` a
    JOIN (SELECT MAX(`id`) AS 'id', `proyecto` FROM `{$this->getTable()}` GROUP BY `proyecto`) e0 ON e0.`id` = a.`id`
WHERE a.`proyecto` = ?";
        return $this->fetchOne($query, [$proyecto_id]);
    }
    public function fetchFirstByProyecto(int $proyecto_id): Model\Proyecto\EstadoProyecto
    {
        $query = "SELECT a.*
FROM `{$this->getTable()}` a
    JOIN (SELECT MIN(`id`) AS 'id', `proyecto` FROM `{$this->getTable()}` GROUP BY `proyecto`) e0 ON e0.`id` = a.`id`
WHERE a.`proyecto` = ?";
        return $this->fetchOne($query, [$proyecto_id]);
    }
    public function fetchRecepcionByProyecto(int $proyecto_id): Model\Proyecto\EstadoProyecto
    {
        $query = "SELECT a.*
FROM `{$this->getTable()}` a
    JOIN `tipo_estado_proyecto` tep ON tep.`id` = a.`estado`
WHERE a.`proyecto` = ? AND tep.`descripcion` = 'Recepción Final'";
        return $this->fetchOne($query, [$proyecto_id]);
    }
}
